<template>
  <section>
    <header>
      <loading :active.sync="isLoading" :is-full-page="fullPage" />
      <nav>
        <h1><a href="/">e-rentes.ch</a></h1>
        <ul>
          <li v-if="$config.ver"><code>{{ $config.ver }}</code></li>
          <li class="float-left">
            <nuxt-link to="/">
              Accueil
            </nuxt-link>
          </li>
          <li v-if="!user" class="float-right">
            <a :href="$config.dibsApiBasePath+'/login/connect'">Connexion</a>
          </li>
          <li v-else class="float-right">
            <a :href="$config.dibsApiBasePath+'/login/disconnect'">Deconnexion</a>
          </li>
        </ul>
      </nav>
    </header>
    <nav class="mainNav"  v-if="user">
      <ul ref="nav">
        <nuxt-link to="/me" tag="li" :class="{'current-state': currentNavState == 0, 'before' : currentNavState >= 0}">
          <a>
            Utilisateur
          </a>
        </nuxt-link><nuxt-link to="/openak" disabled="disabled" tag="li" :class="{'current-state': currentNavState == 1, 'before' : currentNavState >= 1}">
          <a>
            1er pilier
          </a>
        </nuxt-link><nuxt-link to="/openpk" tag="li" :class="{'current-state': currentNavState == 2, 'before' : currentNavState >= 2}">
          <a>
            2ème pilier
          </a>
        </nuxt-link><nuxt-link to="/open3k" tag="li" :class="{'current-state': currentNavState == 3, 'before' : currentNavState >= 3}">
          <a>
            3ème pilier
          </a>
        </nuxt-link><nuxt-link to="/synthese" tag="li" :class="{'current-state': currentNavState == 4, 'before' : currentNavState >= 4}">
          <a>
            Synthèse
          </a>
        </nuxt-link>
      </ul>
    </nav>
  </section>
</template>

<script>
// Import component
  import Loading from 'vue-loading-overlay'
  import { mapMutations } from 'vuex'

  export default {
    components: {
      Loading
    },
    data () {
      return {
        fullPage: true,
        isLoading: true,
        currentNavState: -1
      }
    },
    computed: {
      user () {
        return this.$store.state.user.login
      },
    },
    watch: {
      $route() {
        setTimeout(() => this.computeState())
      }
    },
    mounted () {
      this.loadMe()
      this.$nuxt.$on('check-if-connected', () => {
        this.checkIfConnected()
      })
    },
    methods: {
      computeState() {
        console.log('computeState', this.$refs['nav']);
        let ul = this.$refs['nav'];
        if (!ul) {
          this.currentNavState = -1;
          return;
        }
        let lis = ul.children;
        this.currentNavState = Object.keys(lis).find(key => {
          return lis[key].classList.contains('nuxt-link-active')
        });
      },
      checkIfConnected () {
        if (this.isLoading) {
          return this.$nuxt.$on('me-loaded-once', () => {
            if (!this.user) {
              this.$router.push('/')
            }
          })
        }

        return this._getMe()
        .then(() => {
          this.$nuxt.$emit('user-is-connected')
        })
        .catch(() => {
          this.emptyUser()
          this.$router.push('/')
        })
      },
      loadMe () {
        this._getMe()
        .then((data) => {
          this.setUser(data)
          this.$nuxt.$emit('user-is-connected')
        })
        .catch(() => {
          this.emptyUser()
        })
        .finally(() => {
        setTimeout(() => this.computeState())
          this.isLoading = false
          this.$nuxt.$emit('me-loaded-once')
        })
      },
      disconnect () {
        this._getDisconnect()
        .then((data) => {
          this.loadMe()
          this.$router.push('/')
        })
      },
      ...mapMutations({
        setUser: 'user/setLogin',
        emptyUser: 'user/emptyLogin'
      }),
      _getMe () {
        return this.$api.get('/me')
      },
      _getDisconnect () {
        return this.$api.get('/login/disconnect')
      }
    }
  }
</script>

<style>
  .float-left {
    float: left;
  }
  .float-right {
    float: right;
  }
</style>
